#!/bin/bash
# EX.2019/4/25
# cpanel Fix Account Permissions
# https://github.com/PeachFlame/cPanel-fixperms
# https://www.thecpaneladmin.com/fix-account-permissions/

#rm -f /root/all_time.txt
#rm -f /root/restore_log

/scripts/removeacct --force ezwavene

date >> /root/all_time.txt

filename="single"
exec < $filename

while read line
do

# 帳號名稱
echo "$line" >> /root/restore_log

# 確認帳號大小
#du -sh /backup/cpbackup/daily/account/"$line"/ >> /root/restore_log

# 確認帳號inode數量
#find /backup/cpbackup/daily/account/"$line"/ -printf "%h\n" | cut -d/ -f-2 | sort | uniq -c | sort -rn >> /root/restore_log

# 將帳號public_html先移到/backup
mv /backup/cpbackup/daily/account/"$line"/homedir/public_html /backup

# 單一帳號還原 Start
date >> /root/restore_log

# 執行帳號還原
/scripts/restorepkg --force "$line"

# 單一帳號還原 End
date >> /root/restore_log

# 使用rsync同步public_html
#rsync -rvlHpDtPz /backup/public_html/ /home/"$line"/public_html/
rsync -av /backup/public_html/ /home/"$line"/public_html/

# 單一帳號rsync End
date >> /root/restore_log

# 修正權限 Start
find /home/"$line"/public_html -type d -exec chmod 755 {} \;
find /home/"$line"/public_html -type f | xargs -d$'\n' -r chmod 644
find /home/"$line"/public_html -name '*.cgi' -o -name '*.pl' -o -name '*.perl' | xargs -r chmod 755

chown -R $line:$line /home/"$line"/public_html/
find /home/"$line"/public_html -name .htaccess -exec chown $line.$line {} \;
chown $line:nobody /home/"$line"/public_html

chmod 750 /home/"$line"/public_html
chmod 750 /home/"$line"/public_ftp
# 修正權限 End

# 修正放在 public_html 範圍內網站根目錄權限

for SUBDOMAIN in $(grep -i documentroot /var/cpanel/userdata/"$line"/* | grep -v '.cache\|_SSL' | awk '{print $2}' | grep public_html)
do
  chmod 750 $SUBDOMAIN
  chown $line:nobody $SUBDOMAIN
done

# 將移出的public_html放回原位
mv /backup/public_html /backup/cpbackup/daily/account/"$line"/homedir/

echo "" >> /root/restore_log
echo "===============" >> /root/restore_log
echo "" >> /root/restore_log

done

date >> /root/all_time.txt

echo "" >> /root/all_time.txt
echo "===============" >> /root/all_time.txt
echo "" >> /root/all_time.txt


